#!/bin/bash

PRT_INTVL=${PRT_INTVL:-10}

DIR=$1
MAX_FILES=$2
SIZE=${SIZE:-$((256 * 1024))}

NUM_CREATED=0

create() {
    CHUNKSIZE=$(((RANDOM % 8) + 16))
    CHUNKS=$((RANDOM * SIZE / 32768 / $CHUNKSIZE))
    NUM_CREATED=$((NUM_CREATED + 1))
    dd if=/dev/zero of="$DIR/$file" bs=$CHUNKSIZE count=$CHUNKS
    #echo -n "f"
}

cleanup() {
	echo "write $COUNT ops"
}

trap cleanup EXIT

LAST_TIME=$SECONDS
COUNT=0
LAST_COUNT=0
while /bin/true ; do 
    file=$((RANDOM % MAX_FILES))
    create 2> /dev/null
    COUNT=$((COUNT + 1))
    if [ $((SECONDS - LAST_TIME)) -gt $PRT_INTVL -o $LAST_COUNT -gt 100 ]; then
    	echo "write $COUNT ops"
    	LAST_COUNT=0
	LAST_TIME=$SECONDS
    fi
done
